;=======================================================================
;   ( )		lowspeedmax=8
;=======================================================================
PRG01:	lds		temp,FlgPRG
		sbrc	temp,0
		rjmp	mn_Loop_return
		ori	temp,0b00000001				;  
		sts	FlgPRG,temp
;rjmp mn_Check_END
		; : , , 
		ldi temp,4						;
		rcall RND_load_reset_Timer		;  

	PRG01_Multiplier:
		sts _LoopPRG,FULL				;    256

	PRG01_loopPRG:
		;     HSV
		rcall HSV_2_RGB_max
		rcall Save_Buffer_WS			; 

		ldi	temp,1						; 
		rcall Change_Hue_Z_HSV			; 

		rcall WSsend_WaitLowspeed		;  WS  
		brne PRG01_loopPRG				;   ?

		rcall Dec_Multiplier			; 
		brne PRG01_Multiplier			;   0,  
		rjmp mn_Check_END

;=======================================================================
; (     LED)		lowspeedmax=8 LED30=dtLed/4
;=======================================================================
PRG02:	lds		temp,FlgPRG
		sbrc	temp,1
		rjmp	mn_Loop_return
		ori	temp,0b00000010				;  
		sts	FlgPRG,temp
;rjmp mn_Check_END
		; : , , 
		ldi temp2,2
		ldi temp,3						;
		rcall RND_load					;  
		rcall Speed_correction

		lds	YH,_Multiplier
		lsr	YH
		sts	_Multiplier,YH

	PRG02_Multiplier:
		sts	_Color1,HSV_H
		sts _LoopPRG,FULL				;    256
	PRG02_loopPRG:
		lds	HSV_H,_Color1				;
		rcall HSV_2_RGB_sv

		ldi	temp,5						; 
		ldi ZL,low(_Color1)
		ldi ZH,high(_Color1)
		rcall Change_Hue				; 
		rcall Shift_BufferWS			;       

		rcall WSsend_WaitLowspeed		;  WS  
		brne PRG02_loopPRG				;   ?
		rcall Dec_Multiplier			; 
		brne PRG02_Multiplier			;   0,  
		rjmp mn_Check_END

;=======================================================================
;   (  ,    180 .)		lowspeedmax=16
;=======================================================================
PRG03:	lds		temp,FlgPRG
		sbrc	temp,2
		rjmp	mn_Loop_return
		ori	temp,0b00000100				;  
		sts	FlgPRG,temp
;rjmp mn_Check_END
		; : , , 
		ldi temp,5						;
		rcall RND_load_reset_Timer		;  

	PRG03_Multiplier:
		sts _LoopPRG,FULL				;    256

	PRG03_loopPRG:
		;     HSV
		rcall HSV_2_RGB_max
		rcall Save_Buffer_WS			; 

		lds	temp,_HSV				;   127
		subi temp,127
		sts	_Color2,temp				;
		mov	HSV_H,temp
		rcall HSV_2_RGB_sv
		ldi YL,low(_BuffLED)
		ldi YH,High(_BuffLED)

		PRG03_loopBUF:
		adiw Y,3						; +3 (1 LED)
		ldi temp,0
		rcall Check_Leds3_Y_temp		;   (_BuffLED+LEDS*3-0)
		brcc PRG03_01

		ldi	temp,1
		rcall Save_Buffer_WS_Addr		;  
		rjmp PRG03_loopBUF

	PRG03_01:
		ldi	temp,1						; 
		rcall Change_Hue_Z_HSV			; 

		rcall WSsend_WaitLowspeed		;  WS  
		brne PRG03_loopPRG				;   ?

		rcall Dec_Multiplier			; 
		brne PRG03_Multiplier			;   0,  
		rjmp mn_Check_END

;=======================================================================
; (   )		lowspeedmax=8 LED30=dtLED/4
;=======================================================================
PRG04:	lds		temp,FlgPRG
		sbrc	temp,3
		rjmp	mn_Loop_return
		ori	temp,0b00001000				;  
		sts	FlgPRG,temp
;rjmp mn_Check_END
		rcall Speed_correction
		sbr Flags,0b00010100			; 
		ldi YH,40						;
		ldi XL,9						;- 
		ldi temp2,3						;
		ldi temp,3						;
		rcall RND_load

		;  (  _Color0)
		ldi	XL,low(_RNDColor8)			; _RNDColor8  
		ldi	XH,high(_RNDColor8)
		st X+,full
		ldi temp,128					;  
	PRG04_00:
		st X+,temp
		lsr temp
		brne PRG04_00

		rcall Color2_NULL				; 
		rcall Save_Buffer_WS_background_Y_Color2	; 
	PRG04_Multiplier:
		ldi	XL,low(_RNDColor8)
		ldi	XH,high(_RNDColor8)
		ldi temp,12						; 12
		sts _LoopPRG,temp
	PRG04_loopPRG:
		rcall Clear_RGB
;		lds temp,_LoopPRG
		cpi temp,4
		brcs PRG04_01

		ld HSV_V,X+
		rcall HSV_2_RGB
	PRG04_01:
		rcall Shift_BufferWS			;       

		rcall WSsend_WaitLowspeed		;  WS  
		brne PRG04_loopPRG				;   ?
		rcall Dec_Multiplier			; 
		brne PRG04_Multiplier			;   0,  
		rjmp mn_Check_END

;=======================================================================
;   1...4      		lowspeedmax=8 LED30=144
;=======================================================================
PRG05:	lds		temp,FlgPRG
		sbrc	temp,4
		rjmp	mn_Loop_return
		ori	temp,0b00010000				;  
		sts	FlgPRG,temp
;rjmp mn_Check_END
		ldi temp,4						;
		rcall RND_load_reset_Timer
		lds temp,_Sector				;    1
		inc temp
		sts _Sector,temp
		rcall Color2_NULL				; 
		rcall Speed_correction

	PRG05_Multiplier:
		rcall Addr_Vbuffer				;  

	PRG05_loopPRG:
		rcall Save_Buffer_WS_background_Y_Color2	; 
		rcall RGB_Color1
		rcall Save_Buffer_WS_AddrCHK_SectorY	;    GRB      

		rcall WSsend_WaitLowspeed		;  WS  
		brne PRG05_loopPRG				;   ?

		rcall Dec_Multiplier			; 
		brne PRG05_Multiplier			;   0,  
		rjmp mn_Check_END

;=======================================================================
;   1...4      		lowspeedmax=16 LED30=288
;=======================================================================
PRG06:	lds		temp,FlgPRG
		sbrc	temp,5
		rjmp	mn_Loop_return
		ori	temp,0b00100000				;  
		sts	FlgPRG,temp
;rjmp mn_Check_END
		rcall Speed_correction
		ldi temp,4						;
		ldi temp2,2						; +1
		rcall RND_load

		rcall Background_Color8_Down	;       
	PRG06_Multiplier:
		rcall Addr_Vbuffer				;  

	PRG06_loopPRG:
		rcall Save_Buffer_WS_background_Y_Color2	;  
		rcall RGB_Color1
		rcall Save_Buffer_WS_AddrCHK_SectorY	;    GRB      
	
		rcall WSsend_WaitLowspeed		;  WS  
		brne PRG06_loopPRG				;   ?

		rcall Dec_Multiplier			; 
		brne PRG06_Multiplier			;   0,  
		rjmp mn_Check_END

;=======================================================================
;   1...4  -		lowspeedmax=8 LED30=144
;=======================================================================
PRG07:	lds		temp,FlgPRG
		sbrc	temp,6
		rjmp	mn_Loop_return
		ori	temp,0b01000000				;  
		sts	FlgPRG,temp
;rjmp mn_Check_END
		rcall Speed_correction
		ldi temp,4						;
		rcall RND_load_reset_Timer
		lds temp,_Sector				;    1
		inc temp
		sts _Sector,temp
		rcall Color2_NULL				; 

	PRG07_Multiplier:
		rcall InvertT
		rcall Addr_Vbuffer				;  

	PRG07_loopPRG:
		rcall Save_Buffer_WS_background_Y_Color2	; 
		rcall RGB_Color1
		rcall Save_Buffer_WS_AddrCHK_SectorY	;    GRB      

		rcall WSsend_WaitLowspeed		;  WS  
		brne PRG07_loopPRG				;   ?

		ldi temp,(1<<0)					;  -
		eor flags,temp
		sbrc flags,0
		rjmp PRG07_Multiplier			;   , 
		
		rcall Dec_Multiplier			; 
		brne PRG07_Multiplier			;   0,  
		rjmp mn_Check_END
		
;=======================================================================
;   1...4  -  		lowspeedmax=16 LED30=288
;=======================================================================
PRG08:	lds		temp,FlgPRG
		sbrc	temp,7
		rjmp	mn_Loop_return
		ori	temp,0b10000000				;  
		sts	FlgPRG,temp
;rjmp mn_Check_END
		rcall Speed_correction
		ldi temp,4						;
		ldi temp2,2						; +1
		rcall RND_load

		rcall Background_Color8_Down	;       
	PRG08_Multiplier:
		rcall InvertT
		rcall Addr_Vbuffer				;  

	PRG08_loopPRG:
		rcall Save_Buffer_WS_background_Y_Color2	;  
		rcall RGB_Color1
		rcall Save_Buffer_WS_AddrCHK_SectorY	;    GRB      
	
		rcall WSsend_WaitLowspeed		;  WS  
		brne PRG08_loopPRG				;   ?

		ldi temp,(1<<0)					;  -
		eor flags,temp
		sbrc flags,0
		rjmp PRG08_Multiplier			;   , 
		
		rcall Dec_Multiplier			; 
		brne PRG08_Multiplier			;   0,  
		rjmp mn_Check_END

;=======================================================================
;   1...4        		lowspeedmax=16 LED30=288
;=======================================================================
PRG09:	lds		temp,FlgPRG+1
		sbrc	temp,0
		rjmp	mn_Loop_return
		ori	temp,0b00000001				;  
		sts	FlgPRG+1,temp
;rjmp mn_Check_END
		rcall Speed_correction
		sbr flags,0b00000100			; 
		ldi YH,8
		ldi temp,4						;
		ldi temp2,2						; +1
		rcall RND_load

		lds temp,_Sector				;    1
		inc temp
		sts _Sector,temp

		rcall Color2_NULL				; 
		ldi	XL,low(_RNDColor8)
		ldi	XH,high(_RNDColor8)

	PRG09_Multiplier:
		ld temp,X+
		rcall LoadColor					;   
		rcall Color1_RGB
		rcall Addr_Vbuffer				;  

	PRG09_loopPRG:
		rcall Save_Buffer_WS_background_Y_Color2	; 
		rcall RGB_Color1
		rcall Save_Buffer_WS_AddrCHK_SectorY	;    GRB      

		rcall WSsend_WaitLowspeed		;  WS  
		brne PRG09_loopPRG				;   ?

		rcall Dec_Multiplier			; 
		brne PRG09_Multiplier			;   0,  
		rjmp mn_Check_END

;=======================================================================
;   1...4           		lowspeedmax=8 LED30=144
;=======================================================================
PRG10:	lds		temp,FlgPRG+1
		sbrc	temp,1
		rjmp	mn_Loop_return
		ori	temp,0b00000010				;  
		sts	FlgPRG+1,temp
;rjmp mn_Check_END
		rcall Speed_correction
		sbr flags,0b00000100			; 
		ldi YH,8
		ldi temp2,2						; +1
		ldi temp,3						;
		rcall RND_load

		lds XL,_Sector					;   +1
		inc XL
		sts _Sector,XL

		ldi	XL,low(_RNDColor8)
		ldi	XH,high(_RNDColor8)

	PRG10_Multiplier:
		ld temp,X+
		rcall Background_Color_Down		;;       
		rcall Addr_Vbuffer				;  

	PRG10_loopPRG:
		rcall Save_Buffer_WS_background_Y_Color2	;  
		rcall RGB_Color1
		rcall Save_Buffer_WS_AddrCHK_SectorY	;    GRB      
	
		rcall WSsend_WaitLowspeed		;  WS  
		brne PRG10_loopPRG				;   ?

		rcall Dec_Multiplier			; 
		brne PRG10_Multiplier			;   0,  
		rjmp mn_Check_END

;=======================================================================
;    1...4       		lowspeedmax=8 LED30=144
;=======================================================================
PRG11:	lds		temp,FlgPRG+1
		sbrc	temp,2
		rjmp	mn_Loop_return
		ori	temp,0b00000100				;  
		sts	FlgPRG+1,temp
;rjmp mn_Check_END
		rcall Speed_correction
		ldi temp,4						;
		rcall	RND_load_reset_Timer

		ldi temp,white					;  
		rcall LoadColor
		rcall Color1_RGB

/* =     (   ,   ;   ,   )
        
 1	 (LEDS - 1 + ) * 8 		00001000	7
 2	 (LEDS - 1 + ) * 4 		00000100	5
 3	 (LEDS - 1 + ) * 2 		00000010	3
 4	 (LEDS - 1 + ) * 1 		00000001	1

   ,   ,      
      HSV
    
 ,     .
   .
*/
		ldi temp,64						; 
		mov HSV_V,temp
	PRG11_Multiplier:
		rcall Addr_Vbuffer				;  
		lds temp,_LoopPRG
	PRG11_00:
		sts _Color2,temp

	;     - 
		lds temp,_Lowspeed				;  
		ldi temp1,10
		sub temp1,temp
		sts _LoopPRG,temp1				;   _LoopPRG

	PRG11_loopPRG:
		ldi	temp,2						;  
		rcall Change_Hue_Z_HSV			; 
		;     HSV
		rcall HSV_2_RGB_s
		rcall Save_Buffer_WS			; 

		lds YH,_VBuffCURR
		lds YL,_VBuffCURR+1
		rcall RGB_Color1
		mov ZL,YL
		mov ZH,YH
		rcall Save_Buffer_WS_AddrCHK_Sector	;    GRB      
		sts _VBuffCURR,ZH				;  , ..    
		sts _VBuffCURR+1,ZL

		rcall WSsend_WaitLowspeed		;  WS  
		brne PRG11_loopPRG				;   ?

		sts _VBuffCURR,YH				;  ( Y     )
		sts _VBuffCURR+1,YL

		lds temp,_Color2
		dec temp
		brne PRG11_00

		rcall Dec_Multiplier			; 
		brne PRG11_Multiplier			;   0,  
		rjmp mn_Check_END
		
;=======================================================================
;   8     		lowspeedmax=8 LED30=144
;=======================================================================
PRG12:	lds		temp,FlgPRG+1
		sbrc	temp,3
		rjmp	mn_Loop_return
		ori	temp,0b00001000				;  
		sts	FlgPRG+1,temp
;rjmp mn_Check_END
		rcall Speed_correction
		sbr Flags,0b00010010			;,    _RNDColor8   
		ldi XL,8						;- 
		ldi temp2,8						; +2
		ldi temp,3						;
		rcall RND_load
		rcall Color2_NULL				; 

	PRG12_Multiplier:
		rcall Addr_Vbuffer				;  

	PRG12_loopPRG:
		rcall Save_Buffer_WS_background_Y_Color2	; 

		ldi	XL,low(_RNDColor8)
		ldi	XH,high(_RNDColor8)
		rcall Save_Buffer_WS_AddrCHK_SectorY	;    GRB      

		rcall WSsend_WaitLowspeed		;  WS  
		brne PRG12_loopPRG				;   ?

		rcall Dec_Multiplier			; 
		brne PRG12_Multiplier			;   0,  

		cbr Flags,0b00000010
		rjmp mn_Check_END

;=======================================================================
;   8       		lowspeedmax=8 LED30=144
;=======================================================================
PRG13:	lds		temp,FlgPRG+1
		sbrc	temp,4
		rjmp	mn_Loop_return
		ori	temp,0b00010000				;  
		sts	FlgPRG+1,temp
;rjmp mn_Check_END
		rcall Speed_correction
		sbr Flags,0b00010010			;,    _RNDColor8   
		ldi XL,8						;- 
		ldi temp2,8						; +2
		ldi temp,3						;
		rcall RND_load

		ldi temp,64						; 
		mov HSV_V,temp
		rcall HSV_2_RGB_s
		rcall Color2_RGB

	PRG13_Multiplier:
		rcall Addr_Vbuffer				;  

	PRG13_loopPRG:
		rcall Save_Buffer_WS_background_Y_Color2	;  

		ldi	XL,low(_RNDColor8)
		ldi	XH,high(_RNDColor8)
		rcall Save_Buffer_WS_AddrCHK_SectorY	;    GRB      

		rcall WSsend_WaitLowspeed		;  WS  
		brne PRG13_loopPRG				;   ?

		rcall Dec_Multiplier			; 
		brne PRG13_Multiplier			;   0,  
		cbr Flags,0b00000010
		rjmp mn_Check_END
		
;=======================================================================
; (8  )		lowspeedmax=64
;=======================================================================
PRG14:	lds		temp,FlgPRG+1
		sbrc	temp,5
		rjmp	mn_Loop_return
		ori	temp,0b00100000				;  
		sts	FlgPRG+1,temp
;rjmp mn_Check_END
		ldi temp2,9						; +5
		ldi temp,4						;
		rcall RND_load					;   
		rcall Color2_NULL				; 

		lds	YL,_Lowspeed				;  
		subi YL,-15
		sts	_Lowspeed,YL

	PRG14_Multiplier:
		ldi	temp1,16
		sts _LoopPRG,temp1				;    16

		ldi	XL,low(_RNDColor8)
		ldi	XH,high(_RNDColor8)

	PRG14_loopPRG:
		sbrc flags,0					;   ?   ,   
		rjmp PRG14_loop01

		ld temp,X+
		rcall LoadColor					;   
		rcall Color1_RGB				; 

		ldi YL,low(_Color1)
		ldi YH,High(_Color1)
		rjmp PRG14_loop02
	PRG14_loop01:
		ldi YL,low(_Color2)
		ldi YH,High(_Color2)

	PRG14_loop02:
		rcall Save_Buffer_WS_background	;  

		ldi temp,(1<<0)					;  
		eor flags,temp

		rcall WSsend_WaitLowspeed		;  WS  
		brne PRG14_loopPRG				;   ?
		
		rcall Dec_Multiplier			; 
		brne PRG14_Multiplier			;   0,  
		rjmp mn_Check_END

;=======================================================================
;  (-)		lowspeedmax=10
;=======================================================================
PRG15:	lds		temp,FlgPRG+1
		sbrc	temp,6
		rjmp	mn_Loop_return
		ori	temp,0b01000000				;  
		sts	FlgPRG+1,temp
;rjmp mn_Check_END
		out TCNT2,null
		rcall Color2_NULL				; 
		ldi temp,10						; 
		sts	_Lowspeed,temp
		ldi	temp,10						; 
		sts	_Multiplier,temp

		ldi temp1,2						;- 
		rcall Section_calc

	PRG15_Multiplier:
		ldi	temp1,12
		sts _LoopPRG,temp1				;    12

	PRG15_loopPRG:
		sbrc flags,0					;   ?   ,   
		rjmp PRG15_loop01

		ldi YL,low(_BuffLED)			; 
		ldi YH,High(_BuffLED)
		lds temp1,_LoopPRG				;  ?
		cpi temp1,7
		ldi temp,red
		brlo PRG15_loop02				;   7,  ,  
		ldi temp,blue
		rcall Leds3_lsr2_Y				;  (_BuffLED+LEDS*3/2)

	PRG15_loop02:	
		rcall LoadColor					; RGB-
		lds temp,_Section
		rcall Save_Buffer_WS_Addr		;   
		rjmp PRG15_loop03

	PRG15_loop01:
		rcall Save_Buffer_WS_background_Y_Color2	; 

	PRG15_loop03:
		ldi temp,(1<<0)					;  
		eor flags,temp

		rcall WSsend_WaitLowspeed		;  WS  
		brne PRG15_loopPRG				;   ?
		rcall Dec_Multiplier			; 
		brne PRG15_Multiplier			;   0,  
		rjmp mn_Check_END

;=======================================================================
; (1  )		lowspeedmax=10
;=======================================================================
PRG16:	lds		temp,FlgPRG+1
		sbrc	temp,7
		rjmp	mn_Loop_return
		ori	temp,0b10000000				;  
		sts	FlgPRG+1,temp
;rjmp mn_Check_END
		sbr Flags,0b00001100			; 
		ldi YL,10						; 
		ldi	YH,70						; 
		rcall RND_load_reset_Timer		;  
		rcall Color2_NULL				; 

	PRG16_Multiplier:
		ldi	temp1,2
		sts _LoopPRG,temp1				;    2

	PRG16_loopPRG:
		ldi YL,low(_Color2)
		ldi YH,High(_Color2)
		sbrc flags,0					;   ?   ,   
		rjmp PRG16_loop01
		ldi YL,low(_Color1)
		ldi YH,High(_Color1)

	PRG16_loop01:
		rcall Save_Buffer_WS_background	;  

		ldi temp,(1<<0)					;  
		eor flags,temp

		rcall WSsend_WaitLowspeed		;  WS  
		brne PRG16_loopPRG				;   ?

		rcall Dec_Multiplier			; 
		brne PRG16_Multiplier			;   0,  
		rjmp mn_Check_END

;=======================================================================
;      ( )		lowspeedmax=160
;=======================================================================
PRG17:	lds		temp,FlgPRG+2
		sbrc	temp,0
		rjmp	mn_Loop_return
		ori	temp,0b00000001				;  
		sts	FlgPRG+2,temp
;rjmp mn_Check_END
		ldi temp2,10					; +5
		ldi temp,5						;
		rcall RND_load

		lds	YL,_Lowspeed				;  
		subi YL,-30
		sts	_Lowspeed,YL

	PRG17_Multiplier:
		ldi	temp1,8
		sts _LoopPRG,temp1				;    8

		ldi	XL,low(_RNDColor8)
		ldi	XH,high(_RNDColor8)

	PRG17_loopPRG:
		ld temp,X+
		rcall LoadColor					;   
		rcall Color2_RGB				; 

		rcall Save_Buffer_WS_background_Y_Color2	;  
		rcall WSsend_WaitLowspeed		;  WS  
		brne PRG17_loopPRG				;   ?
		
		rcall Dec_Multiplier			; 
		brne PRG17_Multiplier			;   0,  
		rjmp mn_Check_END

;=======================================================================
; ( ,       )		lowspeedmax=1 LED30=18
;=======================================================================
PRG18:	lds		temp,FlgPRG+2
		sbrc	temp,1
		rjmp	mn_Loop_return
		ori	temp,0b00000010				;  
		sts	FlgPRG+2,temp
;rjmp mn_Check_END
		rcall Speed_correction
		sbr flags,0b00001100			;   
		ldi YL,1						; 
		ldi YH,40						;
		rcall RND_load_reset_Timer

	PRG18_Multiplier:
		rcall RND_load_Sector
		rcall Color2_NULL				; 
		rcall Addr_Vbuffer				;  

	PRG18_loopPRG:
		rcall Save_Buffer_WS_background_Y_Color2	; 
		rcall RGB_Color1
		rcall Save_Buffer_WS_AddrCHK_SectorY	;    GRB      

		rcall WSsend_WaitLowspeed		;  WS  
		brne PRG18_loopPRG				;   ?

		rcall Dec_Multiplier			; 
		brne PRG18_Multiplier			;   0,  
		rjmp mn_Check_END

;=======================================================================
; 		lowspeedmax=16 LED30=288
;=======================================================================
PRG19:	lds		temp,FlgPRG+2
		sbrc	temp,2
		rjmp	mn_Loop_return
		ori	temp,0b00000100				;  
		sts	FlgPRG+2,temp
;rjmp mn_Check_END
		rcall Speed_correction
		ldi temp2,4						; +1
		ldi temp,4						;
		rcall RND_load

		ldi	YL,low(_RNDColor8)			; 
		ldi	YH,high(_RNDColor8)
		ldi temp,red
		st Y+,temp
		st Y+,temp
		st Y+,temp
		ldi temp,blue
		st Y+,temp
		st Y+,temp
		st Y+,temp
		ldi temp,white
		st Y+,temp
		st Y+,temp
		st Y+,temp

		sbr Flags,0b00000010			;,    _RNDColor8
		rcall Color2_NULL				; 
		ldi temp,9						;- 
		sts	_Sector,temp				;  Sector		
		
	PRG19_Multiplier:
		rcall Addr_Vbuffer				;  
;		rcall Addr_VbufferSectorYL1		;  . -  = 1,      
;		lds temp,_LEDS					;   = (LEDS - 9)
;		subi temp,9
;		sts _LoopPRG,temp
		
	PRG19_loopPRG:
		rcall Save_Buffer_WS_background_Y_Color2	; 

		ldi	XL,low(_RNDColor8)
		ldi	XH,high(_RNDColor8)
		rcall Save_Buffer_WS_AddrCHK_SectorY	;    GRB      

		rcall WSsend_WaitLowspeed		;  WS  
		brne PRG19_loopPRG				;   ?

		rcall Dec_Multiplier			; 
		brne PRG19_Multiplier			;   0,  

		cbr Flags,0b00000010
		rjmp mn_Check_END

;=======================================================================
;    (   )		lowspeedmax=16 LED30=288
;=======================================================================
PRG20:	lds		temp,FlgPRG+2
		sbrc	temp,3
		rjmp	mn_Loop_return
		ori	temp,0b00001000				;  
		sts	FlgPRG+2,temp
;rjmp mn_Check_END
		rcall Speed_correction
		sbr flags,0b00010100			;   
		ldi	YH,8
		ldi XL,1
		ldi temp,5						;
		rcall RND_load_reset_Timer
		rcall Color2_NULL				; 
		rcall Save_Buffer_WS_background_Y_Color2	; 

		ldi	XL,low(_RNDColor8-1)
		ldi	XH,high(_RNDColor8-1)
	PRG20_Multiplier:
		rcall Addr_Vbuffer				;  
		adiw X,1						;   

	PRG20_loopPRG:
		ld temp,X
		rcall LoadColor					; 
		rcall Save_Buffer_WS_AddrCHK_SectorY	;    GRB      

		rcall WSsend_WaitLowspeed		;  WS  
		brne PRG20_loopPRG				;   ?

		rcall Dec_Multiplier			; 
		brne PRG20_Multiplier			;   0,  
		rjmp mn_Check_END

;=======================================================================
;    ( 1)		lowspeedmax=16 LED30=288
;=======================================================================
PRG21:	lds		temp,FlgPRG+2
		sbrc	temp,4
		rjmp	mn_Loop_return
		ori	temp,0b00010000				;  
		sts	FlgPRG+2,temp
;rjmp mn_Check_END
		rcall Speed_correction
		sbr Flags,0b00010000			; 
		ldi XL,1						;- 
		ldi temp,4						;
		ldi temp2,2
		rcall RND_load

		rcall Color2_NULL				; 
		ldi	XL,low(_RNDColor8)
		ldi	XH,high(_RNDColor8)

	PRG21_Multiplier:
		rcall Save_Buffer_WS_background_Y_Color2	; 
		rcall Addr_Vbuffer				;  

	PRG21_loopPRG:
		rcall Clear_RGB
		sbrc flags,0					;   ?   ,   
		rjmp PRG21_loop01
		ld temp,X+						;   
		cpi XL,low(_RNDColor8+8)		; 
		brne PRG21_loop00
		ldi	XL,low(_RNDColor8)			; 
		ldi	XH,high(_RNDColor8)		
	PRG21_loop00:
		rcall LoadColor					; 

	PRG21_loop01:
		rcall Save_Buffer_WS_AddrCHK_SectorY	;    GRB      

		ldi temp,(1<<0)					;  
		eor flags,temp	

		rcall WSsend_WaitLowspeed		;  WS  
		brne PRG21_loopPRG				;   ?

		rcall Dec_Multiplier			; 
		brne PRG21_Multiplier			;   0,  
		rjmp mn_Check_END

;=======================================================================
;    (    ,      )		lowspeedmax=45
;=======================================================================
PRG22:	lds		temp,FlgPRG+2
		sbrc	temp,5
		rjmp	mn_Loop_return
		ori	temp,0b00100000				;  
		sts	FlgPRG+2,temp
;rjmp mn_Check_END
		sbr flags,0b00001100			; 
		ldi YH,40						;
		ldi YL,45						;
		rcall RND_load_reset_Timer

	PRG22_Multiplier:
		rcall RND_load_Color
		rcall Color2_NULL				; 
		ldi	temp1,2
		sts _LoopPRG,temp1				;    2

		ldi	XL,low(_RNDColor8)			;  
		ldi	XH,high(_RNDColor8)
		ldi YL,low(_BuffLED)			;  
		ldi YH,High(_BuffLED)

	PRG22_loopPRG:
		sbrc flags,0					;   ?   ,   
		rjmp PRG22_loop01
	PRG22_loop03:
		ld temp,X+
		cpi XL,low(_RNDColor8+8)		; 
		brne PRG22_loop00
		ldi	XL,low(_RNDColor8)			; 
		ldi	XH,high(_RNDColor8)		
	PRG22_loop00:
		rcall LoadColor					;   
		ldi temp,1
		rcall Save_Buffer_WS_Addr
;		clr temp
		rcall Check_Leds3_Y_temp		;  (_BuffLED+LEDS*3-0)
		brcs PRG22_loop03
		rjmp PRG22_loop02
	PRG22_loop01:
		rcall Save_Buffer_WS_background_Y_Color2	; 

	PRG22_loop02:
		ldi temp,(1<<0)					;  
		eor flags,temp

		rcall WSsend_WaitLowspeed		;  WS  
		brne PRG22_loopPRG				;   ?
		
		rcall Dec_Multiplier			; 
		brne PRG22_Multiplier			;   0,  
		rjmp mn_Check_END

;=======================================================================
;     ( 1)		lowspeedmax=16
;=======================================================================
PRG23:	lds		temp,FlgPRG+2
		sbrc	temp,6
		rjmp	mn_Loop_return
		ori	temp,0b01000000				;  
		sts	FlgPRG+2,temp
;rjmp mn_Check_END
		; : , , 
		ldi temp,5						;
		rcall RND_load_reset_Timer		;  
		rcall Save_Buffer_WS_background_Y_Color2
		
	PRG23_Multiplier:
		sts _LoopPRG,FULL				;    256

	PRG23_loopPRG:
		;     HSV
		rcall HSV_2_RGB_max
		ldi YL,low(_BuffLED)
		ldi YH,High(_BuffLED)

	PRG23_loopBUF:
		adiw Y,3						; +3 (1 LED)
		ldi temp,0
		rcall Check_Leds3_Y_temp		;   (_BuffLED+LEDS*3-0)
		brcc PRG23_01

		ldi	temp,1
		rcall Save_Buffer_WS_Addr		;  
		rjmp PRG23_loopBUF

	PRG23_01:
		ldi	temp,1						; 
		rcall Change_Hue_Z_HSV			; 

		rcall WSsend_WaitLowspeed		;  WS  
		brne PRG23_loopPRG				;   ?

		rcall Dec_Multiplier			; 
		brne PRG23_Multiplier			;   0,  
		rjmp mn_Check_END

;=======================================================================
;   (   )		lowspeedmax=8 LED30=144
;=======================================================================
PRG24:	lds		temp,FlgPRG+2
		sbrc	temp,7
		rjmp	mn_Loop_return
		ori	temp,0b10000000				;  
		sts	FlgPRG+2,temp
;rjmp mn_Check_END
		rcall Speed_correction
		sbr flags,0b00010100			;   
		ldi	YH,8
		ldi XL,1
		ldi temp,4						;
		rcall RND_load_reset_Timer
		rcall Color2_NULL				; 

		ldi	XL,low(_RNDColor8-1)
		ldi	XH,high(_RNDColor8-1)
	PRG24_Multiplier:
		rcall Addr_Vbuffer				;  
		lds temp,_LEDS					;-  *2
		lsl temp
		sts _LoopPRG,temp
		adiw X,1						;   

	PRG24_loopPRG:
		sbrc flags,0					;   ?   ,   
		rjmp PRG24_loop01
		ld temp,X
		rcall LoadColor					; 
		rcall Save_Buffer_WS_AddrCHK_SectorY	;    GRB      
		rjmp PRG24_loop02
	PRG24_loop01:
		rcall Save_Buffer_WS_background_Y_Color2	; 

	PRG24_loop02:
		ldi temp,(1<<0)					;  
		eor flags,temp

		rcall WSsend_WaitLowspeed		;  WS  
		brne PRG24_loopPRG				;   ?
		rcall Dec_Multiplier			; 
		brne PRG24_Multiplier			;   0,  
		rjmp mn_Check_END

;=======================================================================
;    (  ,  ) 5 		lowspeedmax=8 LED30=144
;=======================================================================
PRG25:	lds		temp,FlgPRG+3
		sbrc	temp,0
		rjmp	mn_Loop_return
		ori	temp,0b00000001				;  
		sts	FlgPRG+3,temp
;rjmp mn_Check_END
		rcall Speed_correction
		sbr Flags,0b00010010			;,    _RNDColor8   
		ldi XL,5						;- 
		ldi temp2,2						; +1
		ldi temp,3						;
		rcall RND_load
		rcall Color2_NULL				; 

		; 
		ldi	YL,low(_RNDColor8)
		ldi	YH,high(_RNDColor8)
		ld temp,Y+
		st Y+,temp
		st Y+,temp
		st Y,temp

	PRG25_Multiplier:
		rcall Addr_Vbuffer				;  
	PRG25_loopPRG:
		rcall Save_Buffer_WS_background_Y_Color2	; 

		ldi	XL,low(_RNDColor8)
		ldi	XH,high(_RNDColor8)
		rcall Save_Buffer_WS_AddrCHK_SectorY	;    GRB      

		rcall WSsend_WaitLowspeed		;  WS  
		brne PRG25_loopPRG				;   ?

		rcall Dec_Multiplier			; 
		brne PRG25_Multiplier			;   0,  
		cbr Flags,0b00000010
		rjmp mn_Check_END

;=======================================================================
;      (  ,  ) 5 		lowspeedmax=12 LED30=216
;=======================================================================
PRG26:	lds		temp,FlgPRG+3
		sbrc	temp,1
		rjmp	mn_Loop_return
		ori	temp,0b00000010				;  
		sts	FlgPRG+3,temp
;rjmp mn_Check_END
		rcall Speed_correction
		sbr Flags,0b00010010			;,    _RNDColor8   
		ldi XL,5						;- 
		ldi temp2,4						; +1
		ldi temp,3						;
		rcall RND_load

	PRG26_01:	
		; 
		ldi	YL,low(_RNDColor8)
		ldi	YH,high(_RNDColor8)
		ld temp,Y+
		st Y+,temp
		st Y+,temp
		st Y,temp
		ldd temp,Y+2					; ,      
		rcall LoadColor

		ldi temp,64						; 
		mov HSV_V,temp
		rcall HSV_2_RGB_s
		rcall Color2_RGB				; 		
		
	PRG26_Multiplier:
		rcall Addr_Vbuffer				;  

	PRG26_loopPRG:
		rcall Save_Buffer_WS_background_Y_Color2	;  

		ldi	XL,low(_RNDColor8)
		ldi	XH,high(_RNDColor8)
		rcall Save_Buffer_WS_AddrCHK_SectorY	;    GRB      

		rcall WSsend_WaitLowspeed		;  WS  
		brne PRG26_loopPRG				;   ?

		rcall Dec_Multiplier			; 
		brne PRG26_Multiplier			;   0,  
		cbr Flags,0b00000010
		rjmp mn_Check_END

;=======================================================================
; 1.         ,    .    		lowspeedmax=32 LED30=576
;=======================================================================
PRG27:	lds		temp,FlgPRG+3
		sbrc	temp,2
		rjmp	mn_Loop_return
		ori	temp,0b00000100				;  
		sts	FlgPRG+3,temp
;rjmp mn_Check_END
		rcall Speed_correction
		sbr Flags,0b00010100			; ,  
		ldi XL,8						;- 
		ldi YH,8
		ldi temp2,4						; +2
		ldi temp,4						;
		rcall RND_load

	PRG27_Multiplier:
		rcall Mix_Color

		clt
		rcall Addr_Vbuffer				;    	
		movw X,Y
		set
		rcall Addr_Vbuffer				;    
 
	PRG27_loopPRG:
		rcall Clear_RGB					; 
		rcall Save_Buffer_WS

		set								;  
		rcall RGB_Color1
		rcall Save_Buffer_WS_AddrCHK_SectorY	;    GRB      
		clt
		sts _VBuffCURR,XH				;   
		sts _VBuffCURR+1,XL
		movw Z,Y
		movw Y,X

		rcall RGB_Color2				;  
		sbr Flags,0b00100000			;  
		rcall Save_Buffer_WS_AddrCHK_Sector	;    GRB      
		cbr Flags,0b00100000			;   
		sts _VBuffCURR,ZH
		sts _VBuffCURR+1,ZL
		movw X,Y


		rcall WSsend_WaitLowspeed		;  WS  
		brne PRG27_loopPRG				;   ?

		rcall Dec_Multiplier			; 
		brne PRG27_Multiplier			;   0,  
		rjmp mn_Check_END

;=======================================================================
; 2.         ,    .  .    		lowspeedmax=16 LED30=288
;=======================================================================
PRG28:	lds		temp,FlgPRG+3
		sbrc	temp,3
		rjmp	mn_Loop_return
		ori	temp,0b00001000				;  
		sts	FlgPRG+3,temp
;rjmp mn_Check_END
		rcall Speed_correction
		sbr Flags,0b00010100			; ,  
		ldi XL,1						;- 
		ldi YH,8
		ldi temp2,2						; +2
		ldi temp,4						;
		rcall RND_load

		rcall Clear_RGB					; 
		rcall Save_Buffer_WS

	PRG28_Multiplier:
		sbr Flags,0b00100000			;  
		rcall Mix_Color

	PRG28_ChangeDirect:
		rcall Addr_Vbuffer				;    	
		movw X,Y
		rcall InvertT
		rcall Addr_Vbuffer				;    
		rcall InvertT

 		sbrs flags,0					;     2  
		rjmp PRG28_loopPRG
 		lds temp,_LEDS					;(_LEDS/2+1)
		lsr temp
		inc temp
		sts _LoopPRG,temp
 
	PRG28_loopPRG:
		rcall InvertT					;  
		rcall RGB_Color1
		rcall Save_Buffer_WS_AddrCHK_SectorY	;    GRB      
		rcall InvertT
		sts _VBuffCURR,XH				;   
		sts _VBuffCURR+1,XL
		movw Z,Y
		movw Y,X

		rcall RGB_Color2				;  
		rcall Save_Buffer_WS_AddrCHK_Sector	;    GRB      
		sts _VBuffCURR,ZH
		sts _VBuffCURR+1,ZL
		movw X,Y

		rcall WSsend_WaitLowspeed		;  WS  
		brne PRG28_loopPRG				;   ?

		ldi temp,(1<<0)					;  
		eor flags,temp
		sbrs flags,0
		rjmp PRG28_loopPRG_01
		rcall Color2_NULL				;    
		rcall Clear_RGB
		rcall Color1_RGB
		cbr Flags,0b00100000			;   
		rjmp PRG28_ChangeDirect			;   , 

	PRG28_loopPRG_01:
		rcall Dec_Multiplier			; 
		brne PRG28_Multiplier			;   0,  
		rjmp mn_Check_END

;=======================================================================
;    (8  )		lowspeedmax=8
;=======================================================================
PRG29:	lds		temp,FlgPRG+3
		sbrc	temp,4
		rjmp	mn_Loop_return
		ori	temp,0b00010000				;  
		sts	FlgPRG+3,temp
;rjmp mn_Check_END
;		ldi temp,0x04
;		out OCR2,temp

		sbr flags,0b00000100			; 
		ldi	YH,8
		ldi temp2,5
		ldi temp,4						;
		rcall RND_load

		lds	YL,_Lowspeed				;  
		out OCR2,YL

		ldi	XL,low(_RNDColor8)
		ldi	XH,high(_RNDColor8)
	PRG29_Multiplier:
		clr HSV_V						; 
		ld temp,X+						;   
		rcall LoadColor					; 
		clt								; 
	PRG29_00:
		sts _LoopPRG,full				;    10*(2 )

	PRG29_loopPRG:
		rcall HSV_2_RGB					;     HSV
		rcall Save_Buffer_WS			; 
		rcall Change_Bright
		rcall WSsend_WaitLowspeed		;  WS  
		brne PRG29_loopPRG				;   ?

		rcall InvertT
		brts PRG29_00					;   ,    

		rcall Dec_Multiplier			; 
		brne PRG29_Multiplier			;   0,  
		rjmp mn_Check_END

;=======================================================================
; /  		lowspeedmax=1
;=======================================================================
PRG30:	lds		temp,FlgPRG+3
		sbrc	temp,5
		rjmp	mn_Loop_return
		ori	temp,0b00100000				;  
		sts	FlgPRG+3,temp
;rjmp mn_Check_END
		ldi temp,0x01
		out OCR2,temp

		rcall RND_load_reset_Timer
	PRG30_Multiplier:
		rcall RND_load_Color
		clr HSV_V						; 
		clt

	PRG30_loop02:
		sts _LoopPRG,full				;    10*(2 )
	PRG30_loop01:
		ldi YL,low(_BuffLED)			;  
		ldi YH,High(_BuffLED)
		ldi	XL,low(_RNDColor8)			;  
		ldi	XH,high(_RNDColor8)
	PRG30_loopPRG:
		ld temp,X+
		cpi XL,low(_RNDColor8+8)		; 
		brne PRG30_loop00
		ldi	XL,low(_RNDColor8)			; 
		ldi	XH,high(_RNDColor8)		
	PRG30_loop00:
		rcall LoadColor					;   
		rcall HSV_2_RGB					;     HSV		
		ldi temp,1
		rcall Save_Buffer_WS_Addr
;		clr temp
		rcall Check_Leds3_Y_temp		;  (_BuffLED+LEDS*3-0)
		brcs PRG30_loopPRG

		rcall Change_Bright
		rcall WSsend_WaitLowspeed		;  WS  
		brne PRG30_loop01				;   ?

		rcall InvertT
		brts PRG30_loop02				;   ,    		

		rcall Dec_Multiplier			; 
		brne PRG30_Multiplier			;   0,  
		rjmp mn_Check_END

;=======================================================================
; /.   .  1		lowspeedmax=1
;=======================================================================
PRG31:	lds		temp,FlgPRG+3
		sbrc	temp,6
		rjmp	mn_Loop_return
		ori	temp,0b01000000				;  
		sts	FlgPRG+3,temp
;rjmp mn_Check_END
		ldi temp,0x01
		out OCR2,temp
		rcall RND_load_reset_Timer
	PRG31_Multiplier:
		rcall RND_load_Color
		clr HSV_V						; 
		clt
	PRG31_loop02:
		sts _LoopPRG,full				;    10*(2 )
		rcall Clear_RGB					; 
		rcall Save_Buffer_WS

	PRG31_loop01:
		ldi YL,low(_BuffLED)			;  
		ldi YH,High(_BuffLED)
 		sbrs flags,0					; 
		rjmp PRG31_loop03
		ldi YL,low(_BuffLED+3)			;  
		ldi YH,High(_BuffLED+3)
	PRG31_loop03:
		ldi	XL,low(_RNDColor8)			;  
		ldi	XH,high(_RNDColor8)
	PRG31_loopPRG:
		ld temp,X+
		cpi XL,low(_RNDColor8+8)		; 
		brne PRG31_loop00
		ldi	XL,low(_RNDColor8)			; 
		ldi	XH,high(_RNDColor8)		
	PRG31_loop00:
		rcall LoadColor					;   
		rcall HSV_2_RGB					;     HSV		
		ldi temp,1
		rcall Save_Buffer_WS_Addr
		adiw Y,3
;		clr temp
		rcall Check_Leds3_Y_temp		;  (_BuffLED+LEDS*3-0)
		brcs PRG31_loopPRG

		rcall Change_Bright
		rcall WSsend_WaitLowspeed		;  WS  
		brne PRG31_loop01				;   ?

		rcall InvertT
		brts PRG31_loop02				;   ,    		

		ldi temp,(1<<0)					;  
		eor flags,temp
		sbrc flags,0
		rjmp PRG31_loop02

		rcall Dec_Multiplier			; 
		brne PRG31_Multiplier			;   0,  
		rjmp mn_Check_END

;=======================================================================
;     (  8 ).  		lowspeedmax=16 LED30=288
;=======================================================================
PRG32:	lds		temp,FlgPRG+3
		sbrc	temp,7
		rjmp	mn_Loop_return
		ori	temp,0b10000000				;  
		sts	FlgPRG+3,temp
;rjmp mn_Check_END
		rcall Speed_correction
		sbr Flags,0b00010100			; ,  
		ldi XL,1						;- 
		ldi YH,8
		ldi temp2,2						; +2
		ldi temp,4						;
		rcall RND_load
		rcall Color2_NULL				; 

		ldi	r24,low(_RNDColor8)
		ldi	r25,high(_RNDColor8)
	PRG32_Multiplier:
		rcall Save_Buffer_WS_background_Y_Color2
		movw XH:XL,r25:r24
		ld temp,X+
		movw r25:r24,X
		rcall LoadColor					;   
		rcall Leds3_lsr2_Y				;(_BuffLED+LEDS*3/2)
		rcall Addr_Vbuffer_done

	PRG32_ChangeDirect:
		movw X,Y
		lds temp,_LEDS					;(LEDS/2+1)
		lsr temp
		adc temp,null
		inc temp
		sts _LoopPRG,temp
		rcall InvertT

	PRG32_loopPRG:
		rcall InvertT					;  
		rcall Save_Buffer_WS_AddrCHK_SectorY	;    GRB      
		rcall InvertT
		sts _VBuffCURR,XH				;   
		sts _VBuffCURR+1,XL
		movw Z,Y
		movw Y,X
											;  
		rcall Save_Buffer_WS_AddrCHK_Sector	;    GRB      
		sts _VBuffCURR,ZH				;   
		sts _VBuffCURR+1,ZL
		movw X,Y

		rcall WSsend_WaitLowspeed		;  WS  
		brne PRG32_loopPRG				;   ?

		ldi temp,(1<<0)					;  
		eor flags,temp
		sbrs flags,0
		rjmp PRG32_loopPRG_01
		rcall Clear_RGB					;    
		rjmp PRG32_ChangeDirect			;   , 

	PRG32_loopPRG_01:
		rcall Dec_Multiplier			; 
		brne PRG32_Multiplier			;   0,  
		rjmp mn_Check_END

;=======================================================================
;     (  8 ).  		lowspeedmax=8 LED30=144
;=======================================================================
PRG33:	lds		temp,FlgPRG+4
		sbrc	temp,0
		rjmp	mn_Loop_return
		ori	temp,0b00000001				;  
		sts	FlgPRG+4,temp
;rjmp mn_Check_END
		rcall Speed_correction
		sbr Flags,0b00010100			; ,  
		ldi XL,1						;- 
		ldi YH,8
		ldi temp,4						;
		rcall RND_load_reset_Timer
		sts _Color0,temp2

		ldi	r24,low(_RNDColor8)
		ldi	r25,high(_RNDColor8)
	PRG33_Multiplier:
		movw X,r25:r24
		ld temp,X+
		movw r25:r24,X
		rcall LoadColor					;   
		lds temp2,_Color0
		cp temp,temp2					;   
		brne PC+2
		rcall Clear_RGB					; ,  

		rcall Leds3_lsr2_Y				;(_BuffLED+LEDS*3/2)
		rcall Addr_Vbuffer_done
	PRG33_ChangeDirect:
		movw X,Y
		lds temp,_LEDS					;(LEDS/2+1)
		lsr temp
		adc temp,null
		inc temp
		sts _LoopPRG,temp
		rcall InvertT

	PRG33_loopPRG:
		rcall InvertT					;  
		rcall Save_Buffer_WS_AddrCHK_SectorY	;    GRB      
		rcall InvertT
		sts _VBuffCURR,XH				;   
		sts _VBuffCURR+1,XL
		movw Z,Y
		movw Y,X
										;  
		rcall Save_Buffer_WS_AddrCHK_Sector	;    GRB      
		sts _VBuffCURR,ZH				;   
		sts _VBuffCURR+1,ZL
		movw X,Y
 
		rcall WSsend_WaitLowspeed		;  WS  
		brne PRG33_loopPRG				;   ?

		ldi temp,(1<<0)					;  
		eor flags,temp
		sbrs flags,0
		rjmp PRG33_loopPRG_01
		rcall RGB_Color1				;    
		rjmp PRG33_ChangeDirect			;   , 

	PRG33_loopPRG_01:
		rcall Dec_Multiplier			; 
		brne PRG33_Multiplier			;   0,  
		rjmp mn_Check_END

;=======================================================================
;3 ,    1...3  -  		lowspeedmax=16 LED30=288
;=======================================================================
PRG34:	lds		temp,FlgPRG+4
		sbrc	temp,1
		rjmp	mn_Loop_return
		ori	temp,0b00000010				;  
		sts	FlgPRG+4,temp
;rjmp mn_Check_END
		rcall Speed_correction
		ldi temp,3						;3  
		sts _RepeatPRG,temp
	PRG34_Repeat:
		ldi temp2,2						; +2
		ldi temp,4						;
		rcall RND_load

		lds temp,_Sector				;3  
		dec temp
		brne PC+2
		inc temp
		sts _Sector,temp

		rcall Color2_NULL				; 
		ldi temp1,3						;- 
		rcall Section_calc

	PRG34_Multiplier:
		rcall InvertT
		rcall Addr_VbufferSectorYL1		;   . -  = 1,      
		lds temp,_Section				;   =   
		lds temp1,_Sector
		sub temp,temp1
		brts PC+2
		inc temp
		sts _LoopPRG,temp

	PRG34_loopPRG:
		rcall Save_Buffer_WS_background_Y_Color2	; 
		rcall RGB_Color1
		rcall Save_Buffer_Sector		;     

		rcall WSsend_WaitLowspeed		;  WS  
		brne PRG34_loopPRG				;   ?

		ldi temp,(1<<0)					;  -
		eor flags,temp
		sbrc flags,0
		rjmp PRG34_Multiplier			;   , 

		rcall Dec_Multiplier			; 
		brne PRG34_Multiplier			;   0,  
		rcall Dec_Repeat
		brne PRG34_Repeat				;   0,     
		rjmp mn_Check_END

;=======================================================================
;      (  8 ).  		lowspeedmax=16 LED30=288
;=======================================================================
PRG35:	lds		temp,FlgPRG+4
		sbrc	temp,2
		rjmp	mn_Loop_return
		ori	temp,0b00000100				;  
		sts	FlgPRG+4,temp
;rjmp mn_Check_END
		rcall Speed_correction
		sbr Flags,0b00010100			; ,  
		ldi XL,1						;- 
		ldi YH,8
		ldi temp2,2						; +2
		ldi temp,4						;
		rcall RND_load
		rcall Color2_NULL				; 

		ldi	r24,low(_RNDColor8)
		ldi	r25,high(_RNDColor8)
	PRG35_Multiplier:
		rcall Save_Buffer_WS_background_Y_Color2
		movw XH:XL,r25:r24
		ld temp,X+
		movw r25:r24,X
		rcall LoadColor					;   

	PRG35_ChangeDirect:
		rcall Leds3_lsr2_Y				;(_BuffLED+LEDS*3/2)
		rcall Addr_Vbuffer_done
		movw X,Y
		lds temp,_LEDS					;(LEDS/2+1)
		lsr temp
		adc temp,null
		inc temp
		sts _LoopPRG,temp
		rcall InvertT

	PRG35_loopPRG:
		rcall InvertT					;  
		rcall Save_Buffer_WS_AddrCHK_SectorY	;    GRB      
		rcall InvertT
		sts _VBuffCURR,XH				;   
		sts _VBuffCURR+1,XL
		movw Z,Y
		movw Y,X
										;  
		rcall Save_Buffer_WS_AddrCHK_Sector	;    GRB      
		sts _VBuffCURR,ZH				;   
		sts _VBuffCURR+1,ZL
		movw X,Y

		rcall WSsend_WaitLowspeed		;  WS  
		brne PRG35_loopPRG				;   ?

		ldi temp,(1<<0)					;  
		eor flags,temp
		sbrs flags,0
		rjmp PRG35_loopPRG_01
		rcall Clear_RGB					;    
		rjmp PRG35_ChangeDirect			;   , 

	PRG35_loopPRG_01:
		rcall Dec_Multiplier			; 
		brne PRG35_Multiplier			;   0,  
		rjmp mn_Check_END

;=======================================================================
;3 .    ,   		lowspeedmax=40
;=======================================================================
PRG36:	lds		temp,FlgPRG+4
		sbrc	temp,3
		rjmp	mn_Loop_return
		ori	temp,0b00001000				;  
		sts	FlgPRG+4,temp
;rjmp mn_Check_END
		ldi temp2,10					; +5
		ldi temp,4						;
		rcall RND_load

		lds	YL,_Lowspeed				;  
		subi YL,-30
		sts	_Lowspeed,YL

		ldi temp1,3						;- 
		rcall Section_calc
		clt

	PRG36_Multiplier:
		ldi	temp1,8
		sts _LoopPRG,temp1				;    8
		ldi	XL,low(_RNDColor8)
		ldi	XH,high(_RNDColor8)
	PRG36_loopPRG:
		ld temp,X+
		rcall LoadColor					;   
		rcall Color2_RGB				; 
		rcall Save_Buffer_WS_background_Y_Color2	;  

		ldi YL,low(_BuffLED)			;  
		ldi YH,High(_BuffLED)
		rcall Shift_Y_Section			; Y  _Section
		rcall RGB_Color1
		rcall Save_Buffer_WS_Addr

		rcall WSsend_WaitLowspeed		;  WS  
		brne PRG36_loopPRG				;   ?

		rcall Dec_Multiplier			; 
		brne PRG36_Multiplier			;   0,  		
		rjmp mn_Check_END

;=======================================================================
;3 .    ,  		lowspeedmax=32
;=======================================================================
PRG37:	lds		temp,FlgPRG+4
		sbrc	temp,4
		rjmp	mn_Loop_return
		ori	temp,0b00010000				;  
		sts	FlgPRG+4,temp
;rjmp mn_Check_END
		ldi temp2,8						; +3
		ldi temp,3						;
		rcall RND_load					;   
		
		lds	YL,_Lowspeed				;  
		subi YL,-15
		sts	_Lowspeed,YL

		ldi temp1,3						;- 
		rcall Section_calc
		clt

	PRG37_Multiplier:
		ldi	temp1,16
		sts _LoopPRG,temp1				;    16
		ldi	XL,low(_RNDColor8)
		ldi	XH,high(_RNDColor8)
	PRG37_loopPRG:
		rcall Color2_NULL
		sbrc flags,0					;   ?   ,   
		rjmp PRG37_loop01
		ld temp,X+
		rcall LoadColor					;   
		rcall Color2_RGB				; 

	PRG37_loop01:
		rcall Save_Buffer_WS_background_Y_Color2	;  Color2
		ldi YL,low(_BuffLED)			;  
		ldi YH,High(_BuffLED)
		rcall Shift_Y_Section			; Y  _Section
		rcall RGB_Color1
		rcall Save_Buffer_WS_Addr

		ldi temp,(1<<0)					;  
		eor flags,temp

		rcall WSsend_WaitLowspeed		;  WS  
		brne PRG37_loopPRG				;   ?
		rcall Dec_Multiplier			; 
		brne PRG37_Multiplier			;   0,  
		rjmp mn_Check_END

;=======================================================================
;      		lowspeedmax=8 LED30=144
;=======================================================================
PRG38:	lds		temp,FlgPRG+4
		sbrc	temp,5
		rjmp	mn_Loop_return
		ori	temp,0b00100000				;  
		sts	FlgPRG+4,temp
;rjmp mn_Check_END
		rcall Speed_correction
		ldi temp,4						;4  
		sts _RepeatPRG,temp
	PRG38_Repeat:
		sbr Flags,0b00010100			; ,  
		ldi XL,1						;- 
		lds YH,_LEDS					;(LEDS/2)
		lsr YH
		ldi temp2,2						; +2
		ldi temp,3						;
		rcall RND_load
		rcall Color2_NULL				; 

		lds temp3,_LEDS					;  (   ) (LEDS/2+1)
		lsr temp3
		inc temp3
	PRG38_Multiplier:
		clt
		rcall Addr_Vbuffer				;    	
		movw X,Y
		set
		rcall Addr_Vbuffer				;    
 		dec temp3						;        
		sts _LoopPRG,temp3

	PRG38_loopPRG:
		rcall Save_Buffer_WS_background_Y_Color2		; 
		rcall RGB_Color1
		rcall Save_Buffer_WS_AddrCHK_SectorY	;  .     GRB      
		clt
		sts _VBuffCURR,XH				;   
		sts _VBuffCURR+1,XL
		movw Z,Y
		movw Y,X

		rcall Save_Buffer_WS_AddrCHK_Sector	;    GRB      
		sts _VBuffCURR,ZH
		sts _VBuffCURR+1,ZL
		movw X,Y

		;         
		ldi YL,low(_BuffLED)			;  + 2*3
		ldi YH,High(_BuffLED)
		ldi temp,3
		mul temp,temp3
		add YL,r0
		adc YH,r1
		lds temp,_LEDS					;- ((LEDS/2) - 2) * 2
		lsr temp
		sub temp,temp3
		breq PRG38_00
		lsl temp
		rcall Save_Buffer_WS_Addr
	PRG38_00:
		set

		rcall WSsend_WaitLowspeed		;  WS  
		brne PRG38_loopPRG				;   ?
		rcall Dec_Multiplier			; 
		brne PRG38_Multiplier			;   0,  
		rcall Dec_Repeat
		brne PRG38_Repeat				;   0,     
		rjmp mn_Check_END

;=======================================================================
;         		lowspeedmax=12 LED30=216
;=======================================================================
PRG39:	lds		temp,FlgPRG+4
		sbrc	temp,6
		rjmp	mn_Loop_return
		ori	temp,0b01000000				;  
		sts	FlgPRG+4,temp
;rjmp mn_Check_END
		rcall Speed_correction
		ldi temp2,6						;
		ldi temp,3						;
		rcall RND_load
		lds XL,_Sector					; -   2 
		lsl XL
		sts _Sector,XL

		ldi YH,120						;    
		lds	temp,_Lowspeed
	PRG39_02:
		subi YH,20
		lsr temp
		brne PRG39_02
		sts	_Multiplier,YH

		rcall Color2_NULL				; 
		rcall Save_Buffer_WS_background_Y_Color2	; 
	PRG39_Multiplier:
		ldi	XL,low(_RNDColor8)
		ldi	XH,high(_RNDColor8)
	PRG39_01:
		lds temp,_Sector				;  ,   
		sts _LoopPRG,temp
	PRG39_loopPRG:
		rcall RGB_Color2
		sbrc flags,0					;  (   )
		rjmp PRG39_00
		ld temp,X+
		rcall LoadColor					;   
	PRG39_00:
		rcall Shift_BufferWS			;       
		rcall WSsend_WaitLowspeed		;  WS  
		brne PRG39_loopPRG				;   ?

		ldi temp,(1<<0)					;  
		eor flags,temp
		sbrc flags,0
		rjmp PRG39_01

		rcall Dec_Multiplier			; 
		brne PRG39_Multiplier			;   0,  
		rjmp mn_Check_END

;=======================================================================
;  (  ,    ..)		lowspeedmax=4 LED30=72
;=======================================================================
PRG40:	lds		temp,FlgPRG+4
		sbrc	temp,7
		rjmp	mn_Loop_return
		ori	temp,0b10000000				;  
		sts	FlgPRG+4,temp
;rjmp mn_Check_END
		rcall Speed_correction
		sbr Flags,0b00010100			; 
		ldi YH,70						;
		ldi XL,9						;- 
		ldi temp2,2						;
		ldi temp,3						;
		rcall RND_load

		;  (  _Color0)
		ldi	XL,low(_RNDColor8)			; _RNDColor8  
		ldi	XH,high(_RNDColor8)
		st X+,full
		ldi temp,128					;  
	PRG40_00:
		st X+,temp
		lsr temp
		brne PRG40_00

		rcall Color2_NULL				; 
		rcall Save_Buffer_WS_background_Y_Color2	; 
	PRG40_Multiplier:
		ldi	XL,low(_RNDColor8)
		ldi	XH,high(_RNDColor8)
		sbrs flags,0
		rjmp PRG40_01
		ldi	XL,low(_RNDColor8+8)
		ldi	XH,high(_RNDColor8+8)
	PRG40_01:
		ldi temp,7						; 7
		sts _LoopPRG,temp
	PRG40_loopPRG:
		sbrs flags,0
		rjmp PRG40_02
		ld HSV_V,-X
		rjmp PRG40_03
	PRG40_02:	
		ld HSV_V,X+
	PRG40_03:
		rcall HSV_2_RGB
		rcall Shift_BufferWS			;       

		rcall WSsend_WaitLowspeed		;  WS  
		brne PRG40_loopPRG				;   ?

		ldi temp,(1<<0)					;  
		eor flags,temp
		sbrc flags,0
		rjmp PRG40_Multiplier

		rcall Dec_Multiplier			; 
		brne PRG40_Multiplier			;   0,  
		rjmp mn_Check_END

;=======================================================================
;         		lowspeedmax=16 LED30=288
;=======================================================================
PRG41:	lds		temp,FlgPRG+5
		sbrc	temp,0
		rjmp	mn_Loop_return
		ori	temp,0b00000001				;  
		sts	FlgPRG+5,temp
;rjmp mn_Check_END
		rcall Speed_correction
		ldi temp2,4						;
		ldi temp,3						;
		rcall RND_load
		lds XL,_Sector					; -   2 
		lsl XL
		sts _Sector,XL

		ldi YH,120						;    
		lds	temp,_Lowspeed
	PRG41_02:
		subi YH,20
		lsr temp
		brne PRG41_02
		sts	_Multiplier,YH

		rcall Color2_NULL				; 
		rcall Save_Buffer_WS_background_Y_Color2	; 
	PRG41_Multiplier:
		lds temp,_Sector				;  ,   
		sts _LoopPRG,temp
	PRG41_loopPRG:
		rcall RGB_Color2
		sbrs flags,0					;  (   )
		rcall RGB_Color1				;   

		rcall Shift_BufferWS			;       
		rcall WSsend_WaitLowspeed		;  WS  
		brne PRG41_loopPRG				;   ?

		ldi temp,(1<<0)					;  
		eor flags,temp
		sbrc flags,0
		rjmp PRG41_Multiplier

		rcall Dec_Multiplier			; 
		brne PRG41_Multiplier			;   0,  
		rjmp mn_Check_END

;=======================================================================
;1      		lowspeedmax=24 LED30=432
;=======================================================================
PRG42:	lds		temp,FlgPRG+5
		sbrc	temp,1
		rjmp	mn_Loop_return
		ori	temp,0b00000010				;  
		sts	FlgPRG+5,temp
;rjmp mn_Check_END
		rcall Speed_correction
		sbr Flags,0b00010100			; 
		ldi YH,110						;
		ldi XL,1						;- 
		ldi temp2,8						;
		ldi temp,3						;
		rcall RND_load
		
		rcall Clear_RGB					; 
		rcall Save_Buffer_WS			; 
		ldi temp,white
		rcall LoadColor
		rcall Color2_RGB

		ldi	XL,low(_RNDColor8)
		ldi	XH,high(_RNDColor8)
		ld temp,X+
		cpi temp,white
		breq PC-2
		rcall LoadColor					;  ,  
		rcall Color1_RGB

	PRG42_Multiplier:
		ldi temp,1						;  ,   
		sts _LoopPRG,temp
	PRG42_loopPRG:
		rcall RGB_Color2
		sbrs flags,0
		rcall RGB_Color1
		rcall Shift_BufferWS			;       

		rcall WSsend_WaitLowspeed		;  WS  
		brne PRG42_loopPRG				;   ?

		ldi temp,(1<<0)					;  
		eor flags,temp
		sbrc flags,0
		rjmp PRG42_Multiplier

		rcall Dec_Multiplier			; 
		brne PRG42_Multiplier			;   0,  
		rjmp mn_Check_END

;=======================================================================
;       (  )		lowspeedmax=8 LED30=144
;=======================================================================
PRG43:	lds		temp,FlgPRG+5
		sbrc	temp,2
		rjmp	mn_Loop_return
		ori	temp,0b00000100				;  
		sts	FlgPRG+5,temp
;rjmp mn_Check_END
		rcall Speed_correction
		ldi temp,4						;4  
		sts _RepeatPRG,temp
	PRG43_Repeat:
		sbr Flags,0b00010100			; ,  
		ldi XL,1						;- 
		lds YH,_LEDS					;(LEDS/2)
		lsr YH
		ldi temp2,2						; +2
		ldi temp,3						;
		rcall RND_load

		ldi	r24,low(_RNDColor8)
		ldi	r25,high(_RNDColor8)
		lds temp3,_LEDS					;  (   ) (LEDS/2+1)
		lsr temp3
		inc temp3
	PRG43_Multiplier:
		clt
		rcall Addr_Vbuffer				;    	
		movw X,Y
		set
		rcall Addr_Vbuffer				;    
 		dec temp3						;        
		sts _LoopPRG,temp3

		rcall RGB_Color1				; 
		rcall Color2_RGB

		movw r1:r0,X
		movw X,r25:r24
		ld temp,X+
		cpi XL,low(_RNDColor8+8)		; 
		brne PRG43_01
		ldi	XL,low(_RNDColor8)			; 
		ldi	XH,high(_RNDColor8)		
	PRG43_01:
		movw r25:r24,X
		movw X,r1:r0
		rcall LoadColor					;   
		rcall Color1_RGB

	PRG43_loopPRG:
		rcall Clear_RGB
		rcall Save_Buffer_WS			; 
		rcall RGB_Color1
		rcall Save_Buffer_WS_AddrCHK_SectorY	;  .     GRB      
		clt
		sts _VBuffCURR,XH				;   
		sts _VBuffCURR+1,XL
		movw Z,Y
		movw Y,X

		rcall Save_Buffer_WS_AddrCHK_Sector	;    GRB      
		sts _VBuffCURR,ZH
		sts _VBuffCURR+1,ZL
		movw X,Y

		;         
		ldi YL,low(_BuffLED)			;  + 2*3
		ldi YH,High(_BuffLED)
		ldi temp,3
		mul temp,temp3
		add YL,r0
		adc YH,r1
		lds temp,_LEDS					;- ((LEDS/2) - 2) * 2
		lsr temp
		sub temp,temp3
		breq PRG43_00
		lsl temp
		rcall RGB_Color2
		rcall Save_Buffer_WS_Addr
	PRG43_00:
		set

		rcall WSsend_WaitLowspeed		;  WS  
		brne PRG43_loopPRG				;   ?
		rcall Dec_Multiplier			; 
		brne PRG43_Multiplier			;   0,  
		rcall Dec_Repeat
		breq PC+2				;   0,     
		rjmp PRG43_Repeat
		rjmp mn_Check_END

;=======================================================================
;     (   )		lowspeedmax=4
;=======================================================================
PRG44:	lds		temp,FlgPRG+5
		sbrc	temp,3
		rjmp	mn_Loop_return
		ori	temp,0b00001000				;  
		sts	FlgPRG+5,temp
;rjmp mn_Check_END
		ldi temp,0x1E
		out OCR2,temp

		sbr flags,0b00000100			; 
		ldi	YH,7
		ldi temp,3						;
		rcall RND_load_reset_Timer

		ldi	XL,low(_RNDColor8)
		ldi	XH,high(_RNDColor8)
		mov HSV_V,Full
	PRG44_Multiplier:
		ld temp,X+
		cpi temp,white
		breq PRG44_Multiplier
		rcall LoadColor					; ,  
		mov HSV_S,null					; 
		set								; 

	PRG44_00:
		sts _LoopPRG,full				;    10*(2 )

	PRG44_loopPRG:
		rcall HSV_2_RGB					;     HSV
		rcall Save_Buffer_WS			; 

		mov HSV_V,HSV_S
		com HSV_V
		rcall Change_Bright
		com HSV_V
		mov HSV_S,HSV_V
		mov HSV_V,Full

		rcall WSsend_WaitLowspeed		;  WS  
		brne PRG44_loopPRG				;   ?

		rcall InvertT
		brtc PRG44_00					;   ,    

		rcall Dec_Multiplier			; 
		brne PRG44_Multiplier			;   0,  
		rjmp mn_Check_END

;=======================================================================
;   (   )		lowspeedmax=24 LED30=432
;=======================================================================
PRG45:	lds		temp,FlgPRG+5
		sbrc	temp,4
		rjmp	mn_Loop_return
		ori	temp,0b00010000				;  
		sts	FlgPRG+5,temp
;rjmp mn_Check_END
		rcall Speed_correction
		sbr flags,0b00010100			;   
		ldi	YH,5
		lds XL,_LEDS
		ldi temp2,6
		ldi temp,3						;
		rcall RND_load
		rcall Color2_NULL				; 

		ldi	XL,low(_RNDColor8-1)
		ldi	XH,high(_RNDColor8-1)
	PRG45_Multiplier:
		rcall Addr_Vbuffer				;  
		lds temp,_LEDS					;-  *2
		lsl temp
		sts _LoopPRG,temp
		adiw X,1						;   

	PRG45_loopPRG:
		rcall Clear_RGB
		sbrc flags,0					;   ?   ,   
		rjmp PRG45_loop01

		ld temp,X
		rcall LoadColor					; 
		rcall Save_Buffer_WS_AddrCHK_SectorY	;    GRB      
		rjmp PRG45_loop02
	PRG45_loop01:
		rcall Save_Buffer_WS_background_Y_Color2	; 

	PRG45_loop02:
		ldi temp,(1<<0)					;  
		eor flags,temp

		rcall WSsend_WaitLowspeed		;  WS  
		brne PRG45_loopPRG				;   ?
		rcall Dec_Multiplier			; 
		brne PRG45_Multiplier			;   0,  
		rjmp mn_Check_END

;=======================================================================
;       ( )		lowspeedmax=16 LED30=288
;=======================================================================
PRG46:	lds		temp,FlgPRG+5
		sbrc	temp,5
		rjmp	mn_Loop_return
		ori	temp,0b00100000				;  
		sts	FlgPRG+5,temp
;rjmp mn_Check_END
		rcall Speed_correction
		sbr Flags,0b00010100			; 
		ldi YH,90						;
		ldi XL,9						;- 
		ldi temp2,4						;
		ldi temp,3						;
		rcall RND_load

		;  (  _Color0)
		cpi temp,white					; ,  
		brne PC+2
		inc temp
		rcall LoadColor					; temp  
		mov	HSV_V,FULL					; 
		ldi	XL,low(_RNDColor8)			; _RNDColor8  
		ldi	XH,high(_RNDColor8)
		ser temp						; 
	PRG46_00:
		st X+,temp
		subi temp,25
		cpi temp,30
		brne PRG46_00

		rcall Color2_NULL				; 
		rcall Save_Buffer_WS_background_Y_Color2	; 
	PRG46_Multiplier:
		ldi	XL,low(_RNDColor8)
		ldi	XH,high(_RNDColor8)
		ldi temp,7						; 7
		sts _LoopPRG,temp
	PRG46_loopPRG:
		ld HSV_S,X+
		rcall HSV_2_RGB
		rcall Shift_BufferWS			;       

		rcall WSsend_WaitLowspeed		;  WS  
		brne PRG46_loopPRG				;   ?
		rcall Dec_Multiplier			; 
		brne PRG46_Multiplier			;   0,  
		rjmp mn_Check_END

;=======================================================================
;3 ,    1...4  -  		lowspeedmax=16 LED30=288
;=======================================================================
PRG47:	lds		temp,FlgPRG+5
		sbrc	temp,6
		rjmp	mn_Loop_return
		ori	temp,0b01000000				;  
		sts	FlgPRG+5,temp
;rjmp mn_Check_END
		rcall Speed_correction
		ldi temp,3						;3  
		sts _RepeatPRG,temp

	PRG47_Repeat:
		ldi temp2,2						; +2
		ldi temp,4						;
		rcall RND_load
		ldi temp1,3						;- 
		rcall Section_calc
		rcall Background_Color8_Down	;       

	PRG47_Multiplier:
		rcall InvertT
		rcall Addr_VbufferSectorYL1		;   . -  = 1,      
		lds temp,_Section				;   =   
		lds temp1,_Sector
		sub temp,temp1
		brts PC+2
		inc temp
		sts _LoopPRG,temp

	PRG47_loopPRG:
		rcall Save_Buffer_WS_background_Y_Color2	; 
		rcall RGB_Color1
		rcall Save_Buffer_Sector		;     

		rcall WSsend_WaitLowspeed		;  WS  
		brne PRG47_loopPRG				;   ?

		ldi temp,(1<<0)					;  -
		eor flags,temp
		sbrc flags,0
		rjmp PRG47_Multiplier			;   , 

		rcall Dec_Multiplier			; 
		brne PRG47_Multiplier			;   0,  
		rcall Dec_Repeat
		brne PRG47_Repeat				;   0,     
		rjmp mn_Check_END

;=======================================================================
;3 ,     -		lowspeedmax=16 LED30=288
;=======================================================================
PRG48:	lds		temp,FlgPRG+5
		sbrc	temp,7
		rjmp	mn_Loop_return
		ori	temp,0b10000000				;  
		sts	FlgPRG+5,temp
;rjmp mn_Check_END
		rcall Speed_correction
		sbr Flags,0b00010000			; 
		ldi XL,1						;- 
		ldi temp2,2						; +2
		ldi temp,4						;
		rcall RND_load
		ldi temp1,3						;- 
		rcall Section_calc
		rcall Color2_NULL				; 

		rcall Save_Buffer_WS_background_Y_Color2	; 
	PRG48_Multiplier:
		rcall InvertT
		rcall Addr_VbufferSectorYL1		;   . -  = 1,      
		lds temp,_Section				;   =   
		lds temp1,_Sector
		sub temp,temp1
		inc temp
		sts _LoopPRG,temp

	PRG48_loopPRG:
		sbrs flags,0
		rjmp PRG48_00
		rcall Clear_RGB
		rjmp PRG48_01

	PRG48_00:
		rcall RGB_Color1
	PRG48_01:
		rcall Save_Buffer_Sector		;     

		rcall WSsend_WaitLowspeed		;  WS  
		brne PRG48_loopPRG				;   ?

		ldi temp,(1<<0)					;  -
		eor flags,temp
		sbrc flags,0
		rjmp PRG48_Multiplier			;   , 

		rcall Dec_Multiplier			; 
		brne PRG48_Multiplier			;   0,  		
		rjmp mn_Check_END

;=======================================================================
;3 ,     (   )		lowspeedmax=16 LED30=288
;=======================================================================
PRG49:	lds		temp,FlgPRG+6
		sbrc	temp,0
		rjmp	mn_Loop_return
		ori	temp,0b00000001				;  
		sts	FlgPRG+6,temp
;rjmp mn_Check_END
		rcall Speed_correction
		sbr Flags,0b00010100			; 
		ldi XL,1						;- 
		ldi YH,8
		ldi temp2,2						; +2
		ldi temp,4						;
		rcall RND_load
		ldi temp1,3						;- 
		rcall Section_calc
		rcall Color2_NULL				; 
		rcall Save_Buffer_WS_background_Y_Color2	; 

		ldi	XL,low(_RNDColor8)
		ldi	XH,high(_RNDColor8)
	PRG49_Multiplier:
		ld	temp,X+
		rcall LoadColor
		rcall Color1_RGB
	PRG49_02:
		rcall InvertT
		rcall Addr_VbufferSectorYL1		;   . -  = 1,      
		lds temp,_Section				;   =   
		lds temp1,_Sector
		sub temp,temp1
		inc temp
		sts _LoopPRG,temp

	PRG49_loopPRG:
		sbrs flags,0
		rjmp PRG49_00
		rcall Clear_RGB
		rjmp PRG49_01

	PRG49_00:
		rcall RGB_Color1
	PRG49_01:
		rcall Save_Buffer_Sector		;     

		rcall WSsend_WaitLowspeed		;  WS  
		brne PRG49_loopPRG				;   ?

		ldi temp,(1<<0)					;  -
		eor flags,temp
		sbrc flags,0
		rjmp PRG49_02					;   , 

		rcall Dec_Multiplier			; 
		brne PRG49_Multiplier			;   0,  		
		rjmp mn_Check_END

;=======================================================================
;   . 10   		lowspeedmax=16 LED30=288
;=======================================================================
PRG50:	lds		temp,FlgPRG+6
		sbrc	temp,1
		rjmp	mn_Loop_return
		ori	temp,0b00000010				;  
		sts	FlgPRG+6,temp
;rjmp mn_Check_END
		rcall Speed_correction
		sbr Flags,0b00010100			; 
		ldi XL,1						;- 
		ldi YH,8
		ldi temp2,6						; +2
		ldi temp,4						;
		rcall RND_load
		ldi temp,10						;10   
		sts _Section,temp
		rcall Color2_NULL				; 
		rcall Save_Buffer_WS_background_Y_Color2	; 

		ldi	XL,low(_RNDColor8)
		ldi	XH,high(_RNDColor8)
	PRG50_Multiplier:
		ld	temp,X+
		rcall LoadColor
		rcall Color1_RGB
	PRG50_02:
		rcall InvertT
		rcall Addr_VbufferSectorYL1		;   . -  = 1,      
		lds temp,_Section				;   =   
		lds temp1,_Sector
		sub temp,temp1
		inc temp
		sts _LoopPRG,temp

	PRG50_loopPRG:
		sbrs flags,0
		rjmp PRG50_00
		rcall Clear_RGB
		rjmp PRG50_01

	PRG50_00:
		rcall RGB_Color1
	PRG50_01:
		rcall Save_Buffer_Sector		;     

		rcall WSsend_WaitLowspeed		;  WS  
		brne PRG50_loopPRG				;   ?

		ldi temp,(1<<0)					;  -
		eor flags,temp
		sbrc flags,0
		rjmp PRG50_02					;   , 

		rcall Dec_Multiplier			; 
		brne PRG50_Multiplier			;   0,  		
		rjmp mn_Check_END

;=======================================================================
;   , 5   		lowspeedmax=24 LED30=432
;=======================================================================
PRG51:	lds		temp,FlgPRG+6
		sbrc	temp,2
		rjmp	mn_Loop_return
		ori	temp,0b00000100				;  
		sts	FlgPRG+6,temp
;rjmp mn_Check_END
		rcall Speed_correction
		sbr Flags,0b00010100			; 
		ldi XL,1						;- 
		ldi YH,8
		ldi temp2,7						; +2
		ldi temp,3						;
		rcall RND_load
		ldi temp,5						;5   
		sts _Section,temp
		rcall Color2_NULL				; 
		rcall Save_Buffer_WS_background_Y_Color2	; 

		ldi	XL,low(_RNDColor8)
		ldi	XH,high(_RNDColor8)
	PRG51_Multiplier:
		ld	temp,X+
		rcall LoadColor
		rcall Color1_RGB
	PRG51_02:
		rcall InvertT
		rcall Addr_VbufferSectorYL1		;   . -  = 1,      
		lds temp,_Section				;   =   
		lds temp1,_Sector
		sub temp,temp1
		inc temp
		sts _LoopPRG,temp

	PRG51_loopPRG:
		sbrs flags,0
		rjmp PRG51_00
		rcall Clear_RGB
		rjmp PRG51_01

	PRG51_00:
		rcall RGB_Color1
	PRG51_01:
		rcall Save_Buffer_Sector		;     

		rcall WSsend_WaitLowspeed		;  WS  
		brne PRG51_loopPRG				;   ?

		ldi temp,(1<<0)					;  -
		eor flags,temp
		sbrc flags,0
		rjmp PRG51_02					;   , 

		rcall Dec_Multiplier			; 
		brne PRG51_Multiplier			;   0,  		
		rjmp mn_Check_END

;=======================================================================
; (   ) 		lowspeedmax=16 LED30=288
;=======================================================================
PRG52:	lds		temp,FlgPRG+6
		sbrc	temp,3
		rjmp	mn_Loop_return
		ori	temp,0b00001000				;  
		sts	FlgPRG+6,temp
;rjmp mn_Check_END
		rcall Speed_correction
		sbr Flags,0b00010100			; 
		ldi YH,40						;
		ldi XL,9						;- 
		ldi temp2,4						;
		ldi temp,3						;
		rcall RND_load

		rcall Color2_NULL				; 
		rcall Save_Buffer_WS_background_Y_Color2	; 
	PRG52_Multiplier:
		rcall RND_load_Color
		;  (  _Color0)
		ldi	XL,low(_RNDColor8)			; _RNDColor8  
		ldi	XH,high(_RNDColor8)
		st X+,full
		ldi temp,128					;  
	PRG52_00:
		st X+,temp
		lsr temp
		brne PRG52_00

		ldi	XL,low(_RNDColor8)
		ldi	XH,high(_RNDColor8)
		ldi temp,12						; 12
		sts _LoopPRG,temp
	PRG52_loopPRG:
		rcall Clear_RGB
;		lds temp,_LoopPRG
		cpi temp,4
		brcs PRG52_01

		ld HSV_V,X+
		rcall HSV_2_RGB
	PRG52_01:
		rcall Shift_BufferWS			;       

		rcall WSsend_WaitLowspeed		;  WS  
		brne PRG52_loopPRG				;   ?
		rcall Dec_Multiplier			; 
		brne PRG52_Multiplier			;   0,  
		rjmp mn_Check_END

;=======================================================================
;        (   )		lowspeedmax=8 LED30=144
;=======================================================================
PRG53:	lds		temp,FlgPRG+6
		sbrc	temp,4
		rjmp	mn_Loop_return
		ori	temp,0b00010000				;  
		sts	FlgPRG+6,temp
;rjmp mn_Check_END
		rcall Speed_correction
		ldi temp2,2						; +2
		ldi temp,3						;
		rcall RND_load
		rcall Color2_NULL				; 
		rcall Save_Buffer_WS_background_Y_Color2	; 

	PRG53_00:
		ldi	XL,low(_RNDColor8)
		ldi	XH,high(_RNDColor8)
	PRG53_Multiplier:
		ldi temp,high(_RNDColor8+9)
		cpi XL,low(_RNDColor8+9)
		cpc XH,temp
		breq PRG53_00
		ld 	temp,X+
		rcall LoadColor
		rcall Color1_RGB
		clt
	PRG53_04:
		lds temp,_LEDS
		sts _LoopPRG,temp

	PRG53_loopPRG:
		rcall Rnd_On_Off_LED
		ldi temp,1
		rcall Save_Buffer_WS_Addr		;  

		rcall WSsend_WaitLowspeed		;  WS  
		brne PRG53_loopPRG				;   ?

		rcall InvertT
		brts PRG53_04

		rcall Dec_Multiplier			; 
		brne PRG53_Multiplier			;   0,  
		rjmp mn_Check_END

;=======================================================================
;        ( )		lowspeedmax=8 LED30=144
;=======================================================================
PRG54:	lds		temp,FlgPRG+6
		sbrc	temp,5
		rjmp	mn_Loop_return
		ori	temp,0b00100000				;  
		sts	FlgPRG+6,temp
;rjmp mn_Check_END
		rcall Speed_correction
		ldi temp2,2						; +2
		ldi temp,3						;
		rcall RND_load
		rcall Color2_NULL				; 
		rcall Save_Buffer_WS_background_Y_Color2	; 

	PRG54_Multiplier:
		clt
	PRG54_04:
		lds temp,_LEDS
		sts _LoopPRG,temp

	PRG54_00:
		ldi	XL,low(_RNDColor8)
		ldi	XH,high(_RNDColor8)
	PRG54_loopPRG:
		brts PRG54_01
		ldi temp,high(_RNDColor8+9)
		cpi XL,low(_RNDColor8+9)
		cpc XH,temp
		breq PRG54_00
		ld 	temp,X+
		rcall LoadColor
		rcall Color1_RGB

	PRG54_01:
		rcall Rnd_On_Off_LED
		ldi temp,1
		rcall Save_Buffer_WS_Addr		;  

		rcall WSsend_WaitLowspeed		;  WS  
		brne PRG54_loopPRG				;   ?

		rcall InvertT
		brts PRG54_04

		rcall Dec_Multiplier			; 
		brne PRG54_Multiplier			;   0,  
		rjmp mn_Check_END

;=======================================================================
;       ( )		lowspeedmax=8 LED30=144
;=======================================================================
PRG55:	lds		temp,FlgPRG+6
		sbrc	temp,6
		rjmp	mn_Loop_return
		ori	temp,0b01000000				;  
		sts	FlgPRG+6,temp
;rjmp mn_Check_END
		rcall Speed_correction
		ldi temp,4						;4  
		sts _RepeatPRG,temp

		sbr Flags,0b00010100			; ,  
		ldi XL,1						;- 
		lds YH,_LEDS					;(LEDS/2)
		lsr YH
		ldi temp2,2						; +2
		ldi temp,3						;
		rcall RND_load
		rcall Clear_RGB
		lds	temp,_Multiplier			; 
		sts	_Color0,temp

	PRG55_Repeat:
		lds	temp,_Color0				; 
		sts	_Multiplier,temp

		rcall Color2_RGB				;    
		ldi	YL,low(_RNDColor8+4)		;  
		ldi	YH,high(_RNDColor8+4)
		lds temp,_RepeatPRG
		sub YL,temp
		sbc YH,null
		ld temp,Y
		rcall LoadColor
		rcall Color1_RGB

		lds temp3,_LEDS					;  (   ) (LEDS/2+1)
		lsr temp3
		inc temp3
	PRG55_Multiplier:
		clt
		rcall Addr_Vbuffer				;    	
		movw X,Y
		set
		rcall Addr_Vbuffer				;    
 		dec temp3						;        
		sts _LoopPRG,temp3

	PRG55_loopPRG:
		rcall Save_Buffer_WS_background_Y_Color2		; 
		rcall RGB_Color1
		rcall Save_Buffer_WS_AddrCHK_SectorY	;  .     GRB      
		clt
		sts _VBuffCURR,XH				;   
		sts _VBuffCURR+1,XL
		movw Z,Y
		movw Y,X

		rcall Save_Buffer_WS_AddrCHK_Sector	;    GRB      
		sts _VBuffCURR,ZH
		sts _VBuffCURR+1,ZL
		movw X,Y

		;         
		ldi YL,low(_BuffLED)			;  + 2*3
		ldi YH,High(_BuffLED)
		ldi temp,3
		mul temp,temp3
		add YL,r0
		adc YH,r1
		lds temp,_LEDS					;- ((LEDS/2) - 2) * 2
		lsr temp
		sub temp,temp3
		breq PRG55_00
		lsl temp
		rcall Save_Buffer_WS_Addr
	PRG55_00:
		set

		rcall WSsend_WaitLowspeed		;  WS  
		brne PRG55_loopPRG				;   ?
		rcall Dec_Multiplier			; 
		brne PRG55_Multiplier			;   0,  
		rcall Dec_Repeat
		brne PRG55_Repeat				;   0,     
		rjmp mn_Check_END

;=======================================================================
;    (2 )		lowspeedmax=16 LED30=288
;=======================================================================
PRG56:	lds		temp,FlgPRG+6
		sbrc	temp,7
		rjmp mn_Loop_return
		ori	temp,0b10000000				;  
		sts	FlgPRG+6,temp
 ;rjmp mn_Check_END
		lds temp,_LEDS					;    LEDS=39,  = 40
		cpi temp,39
		brne PRG56_Init
		ldi temp,40
		rcall Save_LEDS_RAM

	PRG56_Init:
		rcall Speed_correction
		ldi temp,4						;4  
		sts _RepeatPRG,temp
	PRG56_Repeat:
		sbr Flags,0b00010100			; ,  
		ldi XL,1						;- 
		lds YH,_LEDS					;(LEDS/2)
		lsr YH
;adc YH,null
		ldi temp2,4						; +2
		ldi temp,3						;
		rcall RND_load
		rcall Color2_NULL				; 

		ldi temp1,2						;- 
		rcall Section_calc
		lds temp3,_LEDS					;  (   ) (LEDS/2+1)
		lsr temp3
;adc YH,null
		inc temp3
	PRG56_Multiplier:
		rcall Addr_Vbuffer				;    	
 		dec temp3						;     
		sts _LoopPRG,temp3

	PRG56_loopPRG:
		rcall Save_Buffer_WS_background_Y_Color2		; 
		rcall RGB_Color1
		rcall Save_Buffer_Sector		;     

		;   
		ldi YL,low(_BuffLED)			;  + 2*3
		ldi YH,High(_BuffLED)
		brts PRG56_01
		ldi temp,3
		mul temp,temp3
		add YL,r0
		adc YH,r1
		lds temp,_LEDS					;- ((LEDS/2) - 2)
		lsr temp
		sub temp,temp3
		breq PRG56_00
		mov temp1,temp
		rcall Save_Buffer_WS_Addr		;1- 
;		clr temp
		push r0
		rcall Leds3_lsr2_Y				;(_BuffLED+LEDS*3/2-0)
		pop r0
		add YL,r0
		adc YH,r1
		mov temp,temp1
		rcall Save_Buffer_WS_Addr		;2- 
		rjmp PRG56_00
		;   
	PRG56_01:
		lds temp,_LEDS					;- ((LEDS/2) - 2)
		lsr temp
		sub temp,temp3
		breq PRG56_00
		mov temp1,temp
		rcall Save_Buffer_WS_Addr		;1- 
;		clr temp
		rcall Leds3_lsr2_Y				;(_BuffLED+LEDS*3/2)
		mov temp,temp1
		rcall Save_Buffer_WS_Addr		;2- 

	PRG56_00:
		rcall WSsend_WaitLowspeed		;  WS  
		brne PRG56_loopPRG				;   ?
		rcall Dec_Multiplier			; 
		brne PRG56_Multiplier			;   0,  
		rcall Dec_Repeat
		brne PRG56_Repeat				;   0,     

		lds temp,_LEDS					;  - LED
		cpi temp,40
		brne PRG56_Ext
		ldi temp,39
		rcall Save_LEDS_RAM
	PRG56_Ext:
		rjmp mn_Check_END

;=======================================================================
;
;=======================================================================
PRG57:	lds		temp,FlgPRG+7
		sbrc	temp,0
		rjmp	mn_Loop_return
		ori	temp,0b00000001				;  
		sts	FlgPRG+7,temp
		
		rjmp mn_Check_END

;=======================================================================
;
;=======================================================================
PRG58:	lds		temp,FlgPRG+7
		sbrc	temp,1
		rjmp	mn_Loop_return
		ori	temp,0b00000010				;  
		sts	FlgPRG+7,temp
		
		rjmp mn_Check_END

;=======================================================================
;
;=======================================================================
PRG59:	lds		temp,FlgPRG+7
		sbrc	temp,2
		rjmp	mn_Loop_return
		ori	temp,0b00000100				;  
		sts	FlgPRG+7,temp
		
		rjmp mn_Check_END

;=======================================================================
;
;=======================================================================
PRG60:	lds		temp,FlgPRG+7
		sbrc	temp,3
		rjmp	mn_Loop_return
		ori	temp,0b00001000				;  
		sts	FlgPRG+7,temp
		
		rjmp mn_Check_END

;=======================================================================
;
;=======================================================================
PRG61:	lds		temp,FlgPRG+7
		sbrc	temp,4
		rjmp	mn_Loop_return
		ori	temp,0b00010000				;  
		sts	FlgPRG+7,temp
		
		rjmp mn_Check_END

;=======================================================================
;
;=======================================================================
PRG62:	lds		temp,FlgPRG+7
		sbrc	temp,5
		rjmp	mn_Loop_return
		ori	temp,0b00100000				;  
		sts	FlgPRG+7,temp
		
		rjmp mn_Check_END

;=======================================================================
;
;=======================================================================
PRG63:	lds		temp,FlgPRG+7
		sbrc	temp,6
rjmp 64;		rjmp	mn_Loop_return
		ori	temp,0b01000000				;  
		sts	FlgPRG+7,temp
		
		rjmp mn_Check_END

;=======================================================================
;
;=======================================================================
PRG64:	lds		temp,FlgPRG+7
		sbrc	temp,7
		rjmp	mn_Loop_return
		ori	temp,0b10000000				;  
		sts	FlgPRG+7,temp
		
		rjmp mn_Check_END

